/*
 * Copyright (c) 2005 Versant Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Versant Corporation - initial API and implementation
 */

package org.eclipse.jsr220orm.ui.internal.mapping;

import org.eclipse.jsr220orm.metadata.EntityMetaData;
import org.eclipse.jsr220orm.metadata.MetadataElement;
import org.eclipse.jsr220orm.ui.mapping.MappingUIProvider;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.ui.forms.widgets.FormToolkit;

public class EntityMappingUIProvider implements MappingUIProvider {

	EntityBook book;

	public Control getControl(MetadataElement element, Composite parent, FormToolkit toolkit) {
		if (book == null) {
			book = new EntityBook();
            book.createPartControl(parent, toolkit);
		}
		book.setEntityMetaData((EntityMetaData) element);
		return book.getComposite();
	}

}
